from autotest import TestSet

import testrunners
import copy

def unorderedlists(exp,ans):
    try:
        return exp == sorted(sorted(p) for p in ans)
    except TypeError:
        return False



def tuple_list_in_range(exp,ans):
    lst=[]
    try:
        for i in range(len(exp)):
            for j in range(len(exp[0])):
                lst.append(abs(exp[i][j]-ans[i][j]))
        if max(lst)<.0001:
            return True
        return False
    except TypeError:
        return False


def in_range(exp,ans):
    lst11=[]
    for i in range(len(exp)):
        try:
            if i>1 and exp[i]!=ans[i]:
                return False
            if abs(exp[i]-ans[i])<.0001:
                lst11.append(1)
            else:
                return False
        except TypeError:
            return False
    return True

def print_in_range(exp,ans):
    try:
        ansList=ans.split()
        expList=exp.split()
        copyAns=copy.deepcopy(ansList)
        copyExp=copy.deepcopy(expList)

        copyAns[15]='aaa'
        copyExp[15]='aaa'
        copyAns[23] = 'aaa'
        copyExp[23] = 'aaa'
        copyAns[31] = 'aaa'
        copyExp[31] = 'aaa'

        if copyAns != copyExp:
            return False

        if abs(float(ansList[15])-float(expList[15]))<.0001 and  abs(float(ansList[23])-float(expList[23]))<.0001 and abs(float(ansList[31])-float(expList[31]))<.0001:
            return True
        return False
    except TypeError:
        return False

def num_in_range(exp,ans):
    epsilon=0.0001
    try:
        if abs(exp-ans)<epsilon:
            return True
        return False
    except TypeError:
        return False


def unordered(exp,ans):
    try:
        return type(exp)==type(ans) and sorted(exp) == sorted(ans)
    except TypeError:
        return False



def eq_wrap(lst):
        import polynomial
        pp = polynomial.Polynomial(lst)
        p = copy.deepcopy(pp)
        return p.__eq__(pp)


def add_wrap(lst,parameter_lst):
        import polynomial
        p = polynomial.Polynomial(lst)
        q = polynomial.Polynomial(parameter_lst)
        ans = p.__add__(q)
        return ans.get_coef()

def sub_wrap(lst,parameter_lst):
        import polynomial
        p = polynomial.Polynomial(lst)
        q = polynomial.Polynomial(parameter_lst)
        ans = p.__sub__(q)
        return ans.get_coef()


def mul_wrap(lst,parameter_lst):
        import polynomial
        p = polynomial.Polynomial(lst)
        q = polynomial.Polynomial(parameter_lst)
        ans = p.__mul__(q)
        return ans.get_coef()



def pow_wrap(lst,k):
        import polynomial
        p = polynomial.Polynomial(lst)
        ans = p**k
        return ans.get_coef()

def str_wrap(lst):

        import polynomial
        p = polynomial.Polynomial(lst)
        return print(p)


def floordiv_wrap(lst,parameter_lst):
    import polynomial
    p = polynomial.Polynomial(lst)
    q = polynomial.Polynomial(parameter_lst)

    return p.__floordiv__(q).get_coef()

def mod_wrap(lst,parameter_lst):
        import polynomial
        p = polynomial.Polynomial(lst)
        q = polynomial.Polynomial(parameter_lst)

        return p.__mod__(q).get_coef()


def get_coef_wrap(lst):

        import polynomial
        p = polynomial.Polynomial(lst)
        return p.get_coef()

def get_deg_wrap(lst):

        import polynomial
        p = polynomial.Polynomial(lst)
        return p.get_deg()


def evaluate_wrap(lst,k):

        import polynomial
        p = polynomial.Polynomial(lst)
        return p.evaluate(k)


def derivative_wrap(lst,k):

        import polynomial
        p = polynomial.Polynomial(lst)
        p.differentiate(k)
        return p.get_coef()


def integral_wrap(lst,k):

        import polynomial
        p = polynomial.Polynomial(lst)
        p.integrate(k)
        return p.get_coef()


def definite_integral_wrap(lst,a,b):

        import polynomial
        p = polynomial.Polynomial(lst)
        return p.definite_integral(a,b)



def get_root_wrap(lst,x0,iter):
        import polynomial
        p = polynomial.Polynomial(lst,'roots')
        return p.get_root(x0)


def gcd_wrap(lst, parameter_lst):
    import polynomial
    p = polynomial.Polynomial(lst)
    q = polynomial.Polynomial(parameter_lst)
    return p.gcd(q).get_coef()

def get_roots_wrap(lst):
    import polynomial
    p = polynomial.Polynomial(lst,'roots')
    return p.get_roots()

def compose_wrap(lst,parmeter):
        import polynomial
        p = polynomial.Polynomial(lst)
        q=polynomial.Polynomial(parmeter)
        p.compose(q)
        return p.get_coef()


defaults = {}

q2_def = {'modulename': 'ex6tests', }
q2_examples = {'fm1': {'fname': 'get_coef_wrap',
                            'args': [[4, -7, 8, 1]],
                            'ans': [ [4, -7, 8, 1]],
                            },
               'fm2': {'fname': 'get_deg_wrap',
                            'args': [[4, -7, 8, 1]],
                            'ans': [3],
                            },
              }

q3_def = {'modulename': 'ex6tests', }
q3_examples = {'fm1': {'fname': 'eq_wrap',
                              'args': [[4, -7, 8, 1]],
                              'ans': [True],
                             },
                    'fm2': {'fname': 'add_wrap',
                              'args': [[1,2,3],[-5,-4,-3]],'comparemethod':in_range,
                             'ans': [[-4, -2]],
                              },
                    'fm3': {'fname': 'sub_wrap',
                              'args': [[1,2,3],[-5,-4,-3]],'comparemethod':in_range,
                              'ans': [[6, 6, 6]],
                               },
                    'fm4': {'fname': 'mul_wrap',
                              'args': [[1,2,3],[-5,-4,-3]],'comparemethod':in_range,
                              'ans': [ [-5, -14, -26, -18, -9]],
                               },
                    'fm5': {'fname': 'pow_wrap',
                            'args': [[-2,1], 2],'comparemethod':in_range,
                            'ans': [[4, -4, 1]],
                                                      },
                    'fm6': {'fname': 'str_wrap',
                            'runner':testrunners.print_runner,
                            'args': [[-2,1,4]],
                            'ans': ["4x^2+x-2\n"],
                            'options': {'output': ''}
                            },
                   'fm7': {'fname': 'floordiv_wrap',

                           'args': [[7,-1,5,2], [5,-3,2]],'comparemethod':in_range,
                           'ans': [[4,1]],
                           },
                   'fm8': {'fname': 'mod_wrap',
                           'args': [[7,-1,5,2], [5,-3,2]],'comparemethod':in_range,
                           'ans': [[-13,6]],
                           },
                    }



q4_def = {'modulename': 'ex6tests', }
q4_examples = {'fm1': {'fname': 'evaluate_wrap',
                            'args': [[1, -4, 2],3],'comparemethod':num_in_range,
                            'ans': [7],
                            },
               }

q5_def = {'modulename': 'ex6tests', }
q5_examples = {'fm1': {'fname': 'derivative_wrap',
                            'args': [[1, -4, 2,3,6],2],'comparemethod':in_range,
                            'ans': [[4, 18, 72]],
                            },
               }

q6_def = {'modulename': 'ex6tests', }
q6_examples = {'fm1': {'fname': 'integral_wrap',
                            'args': [[1, -4, 2,3],2],'comparemethod':in_range,
                            'ans': [[0, 0.0, 0.5, -0.6666666666666666, 0.16666666666666666, 0.15]],
                            },
               }

q7_def = {'modulename': 'ex6tests', }
q7_examples = {'fm1': {'fname': 'definite_integral_wrap',
                            'args': [[1, -4, 2],-2,4],'comparemethod':num_in_range,
                            'ans': [29.999999999999996],
                            },
               }

q8_def = {'modulename': 'ex6tests', }
q8_examples = {'fm1': {'fname': 'gcd_wrap',
                            'args': [[1, -4, 2],[1, -4, 2]],'comparemethod':in_range,
                            'ans': [[0.5, -2.0, 1.0]],
                            },
               }

q9_def = {'modulename': 'ex6tests', }
q9_examples = {'fm1': {'fname': 'get_root_wrap',
                            'args': [[-2, 4, 3, 3],0,100],'comparemethod':num_in_range,
                            'ans': [2.999987615708574],
                            },
               }
q10_def = {'modulename': 'ex6tests', }
q10_examples = {'fm1': {'fname': 'get_roots_wrap',
                            'args': [[-2, 4, 3, 3]],'comparemethod':in_range,
                            'ans': [[-1.999999994792993, 2.999603826211005, 3.000396299417213, 3.999999869164775]],
                            },
                }
q11_def = {'modulename': 'ex6tests', }
q11_examples = {'fm1': {'fname': 'compose_wrap',
                            'args': [[-2, 4, 3, 3],[-2, 3, 6, 7]],'comparemethod':in_range,
                            'ans': [[-22, 84, 33, -263, -684, 279, 2181, 3591, 2646, 1029]],
                            },
               }

tsets = {
         'q2': TestSet(q2_def, q2_examples),
         'q3': TestSet(q3_def, q3_examples),
         'q4': TestSet(q4_def, q4_examples),
         'q5': TestSet(q5_def, q5_examples),
         'q6': TestSet(q6_def, q6_examples),
         'q7': TestSet(q7_def, q7_examples),
         'q8': TestSet(q8_def, q8_examples),
         'q9': TestSet(q9_def, q9_examples),
         'q10': TestSet(q10_def, q10_examples),
         'q11': TestSet(q11_def, q11_examples),

}
